Bug 6387

Summary: [3.2 regression] -fpic -gdwarf-2 -g1 combination give ICE in dwarf2out
Product: gcc Reporter: tmwg-gcc
Component: debugAssignee: Jason Merrill <jason>
Status: RESOLVED FIXED    
Severity: normal CC: bangerth, gcc-bugs, jbuck, neroden, reichelt, tmwg-gcc
Priority: P3 Keywords: ice-on-valid-code
Version: 3.0   
Target Milestone: 3.3   
Host: i686-inX-linux Target: i686-inX-linux
Build: i686-inX-linux Known to work:
Known to fail: Last reconfirmed:
Attachments: eh_personality.ii.gz

Description tmwg-gcc 2002-04-20 22:36:00 UTC
 While compiling libstdc++

Release:
3.0.99.9 20020415 (prerelease)

Environment:
System: Linux mwg 2.4.19-pre5-ac1 #1 Thu Apr 4 10:43:33 PST 2002 i686 unknown
Architecture: i686

 
host: i686-inX-linux
build: i686-inX-linux
target: i686-inX-linux
configured with: ../configure --prefix=/usr --exec-prefix=/usr --datadir=/usr/lib --includedir=/usr/local/include --with-gnu-ld --with-gnu-as --with-local-prefix=/usr/local --with-gxx-include-dir=/usr/include/c++3.1 --with-cpp-install-dir=/lib --disable-c-mbchar --enable-threads=posix --with-dwarf2 --enable-shared --disable-nls --with-system-zlib --enable-version-specific-runtime-libs --with-slibdir=/lib --enable-fast-character --enable-interpreter --with-x --enable-clocale=gnu --disable-c-mbchar --enable-c99 --enable-long-long --enable-cheaders=c_std --enable-cxx-flags="-march=i686 -pipe -O2 -fomit-frame-pointer -momit-leaf-frame-pointer -frename-registers -fexpensive-optimizations -fschedule-insns2 -malign-stringops -fno-keep-static-consts -fno-keep-inline-functions -fdata-sections -ffunction-sections" --enable-languages=c,c++,gcov,proto --verbose --host=i686-inX-linux --build=i686-inX-linux --target=i686-inX-linux

How-To-Repeat:
/usr/share/src/devel/gcc/linux/gcc/xgcc -shared-libgcc -B/usr/share/src/devel/gcc/linux/gcc/ -nostdinc++ -L/usr/share/src/devel/gcc/linux/i686-inX-linux/libstdc++-v3/src -L/usr/share/src/devel/gcc/linux/i686-inX-linux/libstdc++-v3/src/.libs -B/usr/lib/gcc/i686-inX-linux/bin/ -B/usr/lib/gcc/i686-inX-linux/lib/ -isystem /usr/lib/gcc/i686-inX-linux/include -I../../../../libstdc++-v3/../gcc -I../../../../libstdc++-v3/../include -I/usr/share/src/devel/gcc/linux/i686-inX-linux/libstdc++-v3/include/i686-inX-linux -I/usr/share/src/devel/gcc/linux/i686-inX-linux/libstdc++-v3/include -I../../../../libstdc++-v3/libsupc++ -g -O2 -D_GNU_SOURCE -fno-implicit-templates -Wall -Wno-format -W -Wwrite-strings -Winline -fdiagnostics-show-location=once -march=i686 -pipe -O2 -fomit-frame-pointer -momit-leaf-frame-pointer -frename-registers -fexpensive-optimizations -fschedule-insns -fschedule-insns2 -malign-stringops -fno-keep-static-consts -fno-keep-inline-functions -fdata-sections -ffunction-sections -ffunction-sections -fdata-sections -g -c ../../../../libstdc++-v3/libsupc++/eh_personality.cc  -fPIC -DPIC -g1 -o eh_personality.o
Comment 1 tmwg-gcc 2002-04-20 22:36:00 UTC
Fix:
 remove -g1
Comment 2 Wolfgang Bangerth 2002-12-11 13:42:08 UTC
State-Changed-From-To: open->feedback
State-Changed-Why: Do I understand this report correctly that this happened 
    during bootstrapping the compiler? If so, did you add any
    special flags?
    
    It is hard to reproduce the problem, since you did not
    provide the preprocessed sources that we so desparately
    need to reproduce something...
    
    W.
Comment 3 tmwg-gcc 2002-12-11 20:06:56 UTC
From: George Garvey <tmwg-gcc@inxservices.com>
To: bangerth@dealii.org, gcc-bugs@gcc.gnu.org, gcc-prs@gcc.gnu.org,
  nobody@gcc.gnu.org, tmwg-gcc@inxservices.com, gcc-gnats@gcc.gnu.org
Cc:  
Subject: Re: debug/6387: -fpic -g1 combination give ICE in dwarf2out
Date: Wed, 11 Dec 2002 20:06:56 -0800

 --/04w6evG8XlLl3ft
 Content-Type: text/plain; charset=us-ascii
 Content-Disposition: inline
 Content-Transfer-Encoding: quoted-printable
 
    I don't know if this is what I originally reported, since it is
 pretty old. But this one has been here for the last couple of releases.
 This is from a make bootstrap of 3.2.1.
 
 On Wed, Dec 11, 2002 at 09:42:08PM -0000, bangerth@dealii.org wrote:
 > Synopsis: -fpic -g1 combination give ICE in dwarf2out
 >=20
 > State-Changed-From-To: open->feedback
 > State-Changed-By: bangerth
 > State-Changed-When: Wed Dec 11 13:42:08 2002
 > State-Changed-Why:
 >     Do I understand this report correctly that this happened=20
 >     during bootstrapping the compiler? If so, did you add any
 >     special flags?
 >    =20
 >     It is hard to reproduce the problem, since you did not
 >     provide the preprocessed sources that we so desparately
 >     need to reproduce something...
 >    =20
 >     W.
 >=20
 > http://gcc.gnu.org/cgi-bin/gnatsweb.pl?cmd=3Dview%20audit-trail&database=
 =3Dgcc&pr=3D6387
 
 /bin/bash ../libtool --tag CXX --tag disable-shared --mode=3Dcompile /usr/s=
 rc/devel/gcc/linux/gcc/xgcc -shared-libgcc -B/usr/src/devel/gcc/linux/gcc/ =
 -nostdinc++  -L/usr/src/devel/gcc/linux/athlon_xp-inX-linux/libstdc++-v3/sr=
 c -L/usr/src/devel/gcc/linux/athlon_xp-inX-linux/libstdc++-v3/src/.libs -B/=
 usr/lib/gcc/athlon_xp-inX-linux/bin/ -B/usr/lib/gcc/athlon_xp-inX-linux/lib=
 / -isystem /usr/lib/gcc/athlon_xp-inX-linux/include -I../../../../libstdc++=
 -v3/../gcc -I../../../../libstdc++-v3/../include -I/usr/src/devel/gcc/linux=
 /athlon_xp-inX-linux/libstdc++-v3/include/athlon_xp-inX-linux -I/usr/src/de=
 vel/gcc/linux/athlon_xp-inX-linux/libstdc++-v3/include -I../../../../libstd=
 c++-v3/libsupc++   -march=3Dathlon-xp -pipe -O2 -fno-keep-static-consts -fn=
 o-keep-inline-functions -fprefetch-loop-arrays -fomit-frame-pointer -momit-=
 leaf-frame-pointer -fschedule-insns -frename-registers -malign-stringops -D=
 __NO_STRING_INLINES -fdata-sections -ffunction-sections -D_GNU_SOURCE -fno-=
 implicit-templates -prefer-pic -Wall -Wno-format -W -Wwrite-strings -Winlin=
 e  -fdiagnostics-show-location=3Donce  -march=3Dathlon-xp -pipe -O2 -fprefe=
 tch-loop-arrays -fomit-frame-pointer -momit-leaf-frame-pointer -fschedule-i=
 nsns -frename-registers -malign-stringops -minline-all-stringops -D__NO_STR=
 ING_INLINES -fno-keep-static-consts -fno-keep-inline-functions -fdata-secti=
 ons -ffunction-sections -ffunction-sections -fdata-sections -g    -c ../../=
 ../../libstdc++-v3/libsupc++/eh_personality.cc
 /usr/src/devel/gcc/linux/gcc/xgcc -shared-libgcc -B/usr/src/devel/gcc/linux=
 /gcc/ -nostdinc++ -L/usr/src/devel/gcc/linux/athlon_xp-inX-linux/libstdc++-=
 v3/src -L/usr/src/devel/gcc/linux/athlon_xp-inX-linux/libstdc++-v3/src/.lib=
 s -B/usr/lib/gcc/athlon_xp-inX-linux/bin/ -B/usr/lib/gcc/athlon_xp-inX-linu=
 x/lib/ -isystem /usr/lib/gcc/athlon_xp-inX-linux/include -I../../../../libs=
 tdc++-v3/../gcc -I../../../../libstdc++-v3/../include -I/usr/src/devel/gcc/=
 linux/athlon_xp-inX-linux/libstdc++-v3/include/athlon_xp-inX-linux -I/usr/s=
 rc/devel/gcc/linux/athlon_xp-inX-linux/libstdc++-v3/include -I../../../../l=
 ibstdc++-v3/libsupc++ -march=3Dathlon-xp -pipe -O2 -fno-keep-static-consts =
 -fno-keep-inline-functions -fprefetch-loop-arrays -fomit-frame-pointer -mom=
 it-leaf-frame-pointer -fschedule-insns -frename-registers -malign-stringops=
  -D__NO_STRING_INLINES -fdata-sections -ffunction-sections -D_GNU_SOURCE -f=
 no-implicit-templates -Wall -Wno-format -W -Wwrite-strings -Winline -fdiagn=
 ostics-show-location=3Donce -march=3Dathlon-xp -pipe -O2 -fprefetch-loop-ar=
 rays -fomit-frame-pointer -momit-leaf-frame-pointer -fschedule-insns -frena=
 me-registers -malign-stringops -minline-all-stringops -D__NO_STRING_INLINES=
  -fno-keep-static-consts -fno-keep-inline-functions -fdata-sections -ffunct=
 ion-sections -ffunction-sections -fdata-sections -g -c ../../../../libstdc+=
 +-v3/libsupc++/eh_personality.cc  -fPIC -DPIC -g1 -o eh_personality.o
 In file included from /usr/src/devel/gcc/linux/athlon_xp-inX-linux/libstdc+=
 +-v3/include/athlon_xp-inX-linux/bits/c++config.h:34,
                  from ../../../../libstdc++-v3/libsupc++/eh_personality.cc:=
 31:
 /usr/src/devel/gcc/linux/athlon_xp-inX-linux/libstdc++-v3/include/athlon_xp=
 -inX-linux/bits/os_defines.h:65:1: warning: "__NO_STRING_INLINES" redefined
 =2E./../../../libstdc++-v3/libsupc++/eh_personality.cc:1:1: warning: this i=
 s the location of the previous definition
 In file included from ../../../../libstdc++-v3/libsupc++/eh_personality.cc:=
 38:
 =2E./../../../gcc/unwind-pe.h: In function `unsigned int=20
    size_of_encoded_value(unsigned char)':
 =2E./../../../gcc/unwind-pe.h:77: warning: control reaches end of non-void=
 =20
    function
 =2E./../../../gcc/unwind-pe.h: In function `_Unwind_Ptr=20
    base_of_encoded_value(unsigned char, _Unwind_Context*)':
 =2E./../../../gcc/unwind-pe.h:107: warning: control reaches end of non-void=
 =20
    function
 =2E./../../../gcc/unwind-pe.h: In function `const unsigned char*=20
    read_encoded_value_with_base(unsigned char, unsigned int, const unsigned=
 =20
    char*, _Unwind_Ptr*)':
 =2E./../../../gcc/unwind-pe.h:182: warning: `_Unwind_Ptr result' might be u=
 sed=20
    uninitialized in this function
 =2E./../../../libstdc++-v3/libsupc++/eh_personality.cc: At global scope:
 =2E./../../../libstdc++-v3/libsupc++/eh_personality.cc:485: Internal compil=
 er=20
    error in dwarf2out_finish, at dwarf2out.c:12183
 Please submit a full bug report,
 with preprocessed source if appropriate.
 See <URL:http://www.gnu.org/software/gcc/bugs.html> for instructions.
 make[4]: *** [eh_personality.lo] Error 1
 make[4]: Leaving directory `/usr/src/devel/gcc/linux/athlon_xp-inX-linux/li=
 bstdc++-v3/libsupc++'
 make[3]: *** [all-recursive] Error 1
 make[3]: Leaving directory `/usr/src/devel/gcc/linux/athlon_xp-inX-linux/li=
 bstdc++-v3'
 make[2]: *** [all-recursive-am] Error 2
 make[2]: Leaving directory `/usr/src/devel/gcc/linux/athlon_xp-inX-linux/li=
 bstdc++-v3'
 make[1]: *** [all-target-libstdc++-v3] Error 2
 make[1]: Leaving directory `/usr/src/devel/gcc/linux'
 make: *** [bootstrap] Error 2
 done 2
 
 --/04w6evG8XlLl3ft
 Content-Type: application/x-gunzip
 Content-Disposition: attachment; filename="eh_personality.ii.gz"
 Content-Transfer-Encoding: base64
 
 H4sICBoK+D0AA2VoX3BlcnNvbmFsaXR5LmlpAN09/XMTx5K/66+YJHVEAgGWbIyxgBQPSKCO
 A87AvVfFpbZWq5G8sNpd9sM2R/z+9uv5/l6tbIXcO1UqWDM93T09PT3dPR/6CU3Qj3fu3JX/
 Zem8bhbJrVu3z/bpl7aEL3fxaVTiqi7yOEubr3eS5MfBT6Tpw3mbZs3tNH8sCpJivY7zBcrS
 HIvCqxLYvx5zd9u6ultXyd0FPsPZ3VWSQKO8vbgbN6dZkUcXJTD+j9uszMCd5knWLrAXcJ42
 9V2AS4p8ma7unP6IJoTVg+9G70/vXFFHC7yE8atl7x58P4Ja90TDJY6btuLsoH2AmD7ogtn3
 4Ki/ghSBioFk2oFkSmH2p3tbElrl7d26aecaof1pF7eM0MHedxzTKWHq3vebIZTe9IqTmbbe
 icYnUAQVTKcPjnaKcn8w2CWbMFhCew7u7xTp/iY+yV9y1tBGSpMnncz4W+4Pmq8lhi8ozRtU
 NtUiXS6jZkZm4N72jCh0bV6nqxwvKN46/R/MkB7sxFhJeZHpOcjjNa7LOMEIigffBgi1dZqv
 0PGx1h9VKJi5BHbu7VZ1p+YAavKBas3k7AcB9q8x/nKZc9FSxvBFg6sc/fj0R/RtwD4ur9Q+
 nMdps8zilWYmD8I8T72mViKqGzCnGqZDG5MH0ocQ54s0zrXu3g8CBPlxcBwFcbBeHdoy9TBL
 hdvmaZEjUgGqRnQQUc0/jxjcjJbUTdUmDf2TAPE/kDlZoug8goFaQ9Hx/VkYJikqvGjX5fGk
 A6jCTVIs8PGRH+Z4cjjjqsDrL0kz6AVlIc3jBi+25L1uivIszkIkJQzp32a2LK5Iw5KxdEnt
 SbfO/4QedM21gTRXsndq6L60RTOT3yq8pkTRIj0j1iPcFmzGykIgiySWTKEhnygikxMkAPYm
 Ql2IQ9g9JBQNmA3ObNHlwC0Ds4wg6oRwEK1wE63nUdJW0Tq+QMOzIl2MUHNaFedoOGK885aL
 op1nGMVNsURDaF/kdYOS07hCN6MoBzOs2gH6uGmqdN42GPo6BPASvK0oGhGUHB/pCCBLd4JM
 igYwZtfD6I6VTsMgFKLENLo/OVPCoBJNsXBRg7sKWBIyeITKWE4r88PATXgweYYETLrLrIgb
 RtYztP3I9qSqi1Lvbnb1/l6113IkGQPXoB+mPebWcB7X2CcHaRBNZtrrcLM1X6a2ztwJMPBO
 AMrpl+syegXZeXkzJWmJ89pc7kSmvYXqsytb8vtdxLoDPq8vWAhipvd6+dqi9iIrkjjDWh7C
 9hA1iH3LBQA+WGXEV27qJvE6XrOIm5jIgn2tP072f59RN4eJSsq0Pi2qhnbupliP5zMJZpSD
 UhTnuArWtuAxVToRuR6RwIlxcKl44tHf9LA7mgjZyuh6A99vqLswqH6wP7eyrdfkvlc/erXX
 +trdo/6GYyd9u/749Bilq5ibnY3cxn5ugaVzFB1z5XP1rtWtrsHqzY7uAV6Hm62Y6ecX7mDM
 rz7OnTx7XPco4iMKSgHF8U70dfN0XFWwADiDa4wt52y5S86uyZg+2Jy9bLeS28hmXxR6b0Jq
 y2D4ArnbXlyzB7qFCvWkY9nknWp33aud9W/bnvZZT8VI/jmd3kmH+3V2m3VWjnS419uNB/tc
 Vz3YZ2dKwj4h6XkjNzU9IpAM2VrnhmvQN1nTK0FBNzYq3LSUkGcpyflKKqzs3ojscdisifEc
 9M1s9JKtL2z0MJx1Miwk7mfcsT2D3umQfurRsw/tNp3wKQddcwd9M2pX1Y3lVXVD190+mber
 Mpj10d5gvtXk2VSJHhmdnSr1NgrR3Rm/6R30TlTtWNG31fStR6pPkminffpeY+V2zLPQ9Vy1
 /rThCqxafTZxdPpqlWMkh7xbZG8jB668poaIqs8Gj05oCI1GWkbeT26MJhtWvj7bQE4H+1Dc
 dg50bRN1cNKLFXJoyU5derb8WPvs8CBGQ83Vy01H0dlIOzzw8F333kXznwAj6cq6I/NqwMge
 8OMMgQ1/G+eDTqBrnb6wz6KZqKfGdrM0HlR2UdRG5I+ZW8/SwASA/uWBYAPWkrnvqaVDRqrJ
 H3ZmDfnBNT1ooy9tvCAZYX9DG15Aawd9QpKWqXNDEIDmKPJ1RAjKBnDS5RTH5NCLRIdqHTBD
 oPD//akXiWrOAEKb936Jwv8PD8ICDY+EbCg5EuImc+9LvFhUVq0YPPgTFFnvC9cXinbhr1i5
 FVyX0rzwN1kXC+yvIcbvs16ldaxg57OcTpGcmlnF4EuTMR6aikNdHn6rLF3bVZIGqWRidblm
 hLqOiETRWZx9nP7ODlxE0bLmbSz2FmJ0RLEwmYldoQmmSde4SwFrDOZ3UQda15vqz+fZZ6N/
 WmWSFclnX0dohb+PhN1KHWkxKz/jr2Yb75RMy0QM78DLF7AsBjoMkeRNQKFYJZ9FPlVZ1r72
 mroIgE4cyzTrxsEAfDgkEEwyt55NCDZn7FpdcaI6ibO48iqPAdcqQHvE4P/gYQQGjasQ6EKG
 czEagRW4BJ8Axwt7IfYeArRhg+f46uQUL7QjhbarYALtD+T+LC2LyriK19ZM5jVVWlRp81Ue
 MJt6DwDajLLVXVDhtdEyrhsyYagLZyTSxJFA/r0E9xDgQI6XnpNlCuEC10nFN5fBfBjFM3Pe
 yR4LIOKPRTVlhRsl3MTJKeEFa6wQKZRFliZUBD65SSjyRbVM81MMkqNVOr6ipOjl2bJVG1cL
 8k0DAkY+U0tYY3qmjZw0ox6lqDAw0FKG4RIZ3fOey/um9cMeGWLSIiZ6ZImZVpEzhylxnBQh
 YlTDhLho2/X6q91IceidTwJUmsouAmsSMuLqTBf1Gqi0eePtyToqznN2REAAf07zxaxbNGsu
 GtWPNfjzF5t6T4EYequlZ5D0rhd54th2m73qnK1Nm4a1OpfjyriqyGHYeIGr2ishqD4H9WUy
 8tXS71IfOjDoQJK0kLYsKGtwAbAhItG1bukSGBNbEJUmbonvrMjiJs2wIXhhgEz15NLdIOh5
 bAkaCir8pU0rXTmhsCQqG9BPqPZMtXlcVSmuglwFu88b6v3vWAlFKxq3TJwTxW4cxy6/hWNT
 fj5GX9ipw2dHeTKsQ054J7xQK66TfoYI6BwvR0RgHq9CBXOqknmsSDmuHn9D+OFGHY0CEI8F
 BgOnkvgnSPNi9GoajSAek5hVNOxAKx83LLxAIsowK3mEgWSkYQ0ARdsqtFod66Tqo11Je6J5
 XHo19VZR6WOX1vgqeKyCat2V1aXDYgLkBA0yXEAybLCa0rUD8RWEHPq279BZKRTXuyJevPKr
 7tl+lajeN8jycAFpYQM0vm9PJH9jFuYgEe3Qps7dP9XUokqlrEUl0KO9MF2TasXJVkJazlWB
 7kktAyykx1rmWGtAtQW1m6tefXh1TV5rWg9PNNZ25ZtaapSAjQd20stSMH2VZ5kb5GYG6YyO
 SD7xP1+SDOFoZrcjeZrOhi8CDUmGprPhu0BDOum7Gj4TDQPuXBtdpb8uiu277uLYXgouji0E
 oouywqu0buhU62p8XlQL3hxCrolzZneT2SIANc5w0mgJ2W6gcGxp4/EZUQU0tW6XmrjSFYQ0
 m8JeBWXOGLAf6QqkVqzTxO8XyxjWF9+T3NRwsgcR7F00PEI3aQRF9nYcYBC8zGExZphJ3PcN
 hN113dzxtkghCaQGzHVmMrEPGyubzf09UlCXOJE9VivHGYSNiXXRCgpzXsruifXoSWgLwWD1
 0Da8BozBLsi/m1tzfYCa1mDZZ+JNlmGF7u6X0idNL5YQjcX155mvN6HmmroNBpx5jgctgX0i
 hY8+XZNgVMUGrPUltGGxvu3BKJySxwf2ToLNo+deq3aNjEHSzUPiJwKzY07d2m0mMQCp9R0Y
 8jag0d5WLfBFgssm1MRUHaspKS3aJnRhicYxO+nqFfp6lc7yqwjW7PZ3uguBZnTMtlBM1c4Q
 2CVdXpybDa7vFFhivtbrOKkKPZE58amn7YlpGi5z2MjKZltANIWMVD7anCYyUY30nLUFIxLR
 SM9JA8v3Op3HfYcPuvbriW+XEQpiZsddTjiQmf4mQ3Lgrvj2ZZOBuwtdxfmiWPvupXJImkas
 BZidvcbYuc1q7oqnObvljb1tx2rfm8DM22X4qKGeumxgkub+47UMISgzp2oTcE+Yi+WG9ZFe
 LtLT2tTxu7ksm2pmFlVukUwEIynciAyhVbTAK6ukxqWFCkMpJ3Bp3unlfFZo6DJuzd+wQCUd
 y6bVbdb4TmDTVUBR9o6lnx1b5hpCqRxBlJ4DTVfQlA7QHhIMigMr5q/C59a07bWKtPTMXGfi
 9pq2Fl5nRG4GZrt9Q2NBWh8cuXyZYFiAeTcxL+p2nn7c/737BE22gZQEzHdAbN2X2KerE1ND
 Rtrrm10geXBnPGR9dx0JdJABUjk5PLNY0BnIwClYBdvTHauP9393FIGrMx9/04z6RfFx//dZ
 uJocbt0AknTUEdtiVdvHQWJhXHXlF/wr86r3yJ2hSxw8Hs9VfZOJ1YhjRbxTe0IUvxPHhsCy
 3QlMjs0WIsv/YpH15tkQ2vqvFdqnf0mh1Ypr1zaOQ0wxToI3M9lKjrukoUxmoD/dlANEuZkN
 UhWGdssx8BC1Fmp2MGAdZ1mRgPpJZwn+6Dx8ylqYz8IwXImNK1/j9XyMTNzmCGwi4GEZIm5G
 RxxtoMd3d9CBZYWxgTXgHFGIZBO0G/ZSurEW79qRmgK4zulZ57UBhTbwdpkhXgYd1Ag+JvTF
 t/vhh5BEqGmgPrueslkpmqJOLyLQsDiDWSNGAoYCikyNoABrnDfXVkW9N/GcTFLLD/TgyAt2
 4lxiMd5lwhcpR4KGwPuyzZMRR9qVnyryyN9SPxU1lod/4mo1Mr/5r9/p/WP4dXzbddNCFz3f
 GT4WZa1wg/Mzz5H/eO2oq9GQWPKEnKDfBoOheS1rp3IKVZqvulrUHZTIdRKzFKZJK29LVrjM
 4sT30o2GH1aObfqiN00yHFe0qR3R/IQOD8PPL1rXHtafG5h2SibkWwbqHQ4Uqf/zud7cjKTW
 e1y/0PAdHmzEeNT7Qsf686Jn1/QB/0oYcYeDvxodlgoDTOK8yFNYT4m5WqYZpuO4eXR/Qvcn
 zhZbqGNkHS3j5rT73hjR0FDqwgMPfxbZmS9BoO/GDZkowLeJlnkErp5kgdkoNSfYd2Nv2GiK
 2N9pDRZxmav8r7HuzGvQ8eTUpkIPedikuh9d6XRtxhZr4pth9imVL7VcOyTFDbh9DPUgR1eZ
 eS0M70WnzaVyYAbXSbJQJJq/3RvToNczf5lGwKCycY02SemZqJQejUrP5C5Ou8byyYwFzov1
 VtgF3wxvRhHr97wYdq1kexJhYQmqGlmHdq/r+XbTKzAJVuZ++EUry8rg5Aw0XT4/Yqxt+SJd
 pc3YEwIucFL696pcWBI0dS74y7+ehVUPFoQ19eR7DVxfmEjNZ118GL36EOpoj16ZXCz/T3Cx
 6slFD+nSzBugI6H4n60s3i2N0C6BXAis3S6N7+W/Et8641+ExL+PIgW2v/196iP4L8t/Qf49
 jjiwnXuuIeteSTiLOW+Kcwjrz0kzZzOxPE+CzkvA6exH9jxpivVcC8PGSHAQRfQv/9YwR72e
 14TtuoPvwHGLK3NvMgD4SQdq/7bhZtIdbOsM+CN9c6evXMdN4g8ESiiwYowj5yxzIByDALtu
 50XZyMv1BqtQAU5O2f3AsmDJOs1SfAYXaZunmemMdF6oMrfccAMBgSsFKOyePSwVVZQ4L2WK
 oyCP/nc3W1UxuRkoWiztoMkI8Mm57A5Yc1ksm5oFjCFok30GTayYgDfWS02d4JtjS8wBL52c
 mIciwGVFvIjPVtqSxUs+/i7tJs7w2p953O/IjV7ttyZArXfy00baD6WEf0yDvyavCuT78qqI
 5hdnRkFtfKW5Q7OkWFrfU+t7pn/nYbFexFL4M5NV/atNk2TB9e8sp2Z0zeI7szCuHZJ0MTIL
 mKk2y0iRXkKDar2AbIkY37FDqrZh2AssTknmlLRmEc336CXCuptlpIiOsvaICXwDEQ3FkwAj
 9E28UUJENyRFM3SpN6LKAt/hX9lsLN6n+KQjIBC0kpQTLJf0dsbhn6bpUbTK2yi5uDD0Xf5+
 giqi+WBbFI48eJ8utD7BN/T4EdpDv9A/j9Ft+McSkIaKJhauhcwVN0eUj5H+dUGW2m8yVI+i
 LzPyvzvk1yXQIwKP7hIwVlrhNS/8N1YoOfoSok//+p4c6IbDnQFLd5b4polbli3oszoh8yhV
 yKM3Wh1XIE+NYXAMbKEawyTZ9P00zN5qNbZs7KquZm1XJRMb+8mja/3AWJ/G9MAxSUEtrF/I
 O/jzibf5eZovbkPPJdWj7Rv2Jkfyymm+LLYiJRttL1L+s2x7W7ZS+7a3btGdW3v+sA94v1lc
 10g25KevSvCy0uSYesyybsi9qyExiZe07iytmjbO0D89QLPBwIBRbvJNdH4aNwDJiiQ8P1gl
 uZrHi0giBnPLuOpk1mhiMWyy888AqGQDybeB+LZpI36YKToFPyAjByZoLx3ANscXJU4avLAg
 CaiNBNEz9KJ06CFiyJOSUOB9NkPJaTabIUpVFQ99LLt0tQabCf+EHvSbHZrWwgAWRQZ0krhd
 nTb+8TFWA92FIPeZtp1eomsQ8+FqXtQ4ckeIE73kv/m5lZWYDjqmYkQYj+fp2YSuaEzryQVb
 +JeeAY8IEv6Lefe2NDWeGS9ISNTWDBrYc0QCckUvq/QMJHPMwGTtDQThbAWrXPVoyOe0rBrN
 TFgfAMVcNFSz2Dx2dy59UKCNwHfaONhlw9ExYs2HNL3yjbkqWn9NYjcRheWWiVZq3h9lA132
 12w1GNQ2EdWe4yXMEkcIiB20CNNFDxnIHcWGxCmF70p/M95HjxzELuYftsL8g8YQg5px8ysF
 r2sZpQRxRx2VRUoe0oxKMQKzECQ5wEI9Dh104Cgwb7AoooTkrOxO0A3604pONXHihRcV80/d
 W2Ty/F0UFWACK40NPwegEnHdDMXtKTHzwTe1JzxlC8SGA2lg+ZEcA7fsUBnnwbeSEur9F1HK
 68b104TSlk5Fls6BRX/CHH4zbQboUN/OUJveIxhr10MjwS4DEw7m9F4HhO9WpHO7O/pAwaO/
 F9XCXEjV9Wzzdra8D2oieHe+NQaHibdN1YFBzElx6b6rO89lIPCUL2UhrNotfokO5+2aroPR
 h5On0es30cnzJ+/evIawc28sSn99c/L85W+vo+f/ePr87fuXb15HT598+O3FewCaKKAn75+8
 it6+ePLu+TR6fnLy5gSqp77qiazeHyvCJ/8B9e/ev3kL5Qey/PnrZ9GbX6H8ydN/h4p7suLF
 k9fPXj0/Ad4+vH4GNYey5uVrgH71Knr65vX75/8gTN6XdaTs5esPz6MPr//+krY7GlxKSZ7g
 mBxSeQrymvFfQw1rnHgkyB4F7UkAcfLPM1A4ztsy+jUn52pc6ts+4x/ihR3LCdXyYfdrkQov
 qVWZBUBFPwx4Wqi3oDOOuzHRJFgzZap+6aowPR+KF+oIhvFwAMf1JGHyB0/hcIuRe1rAVLto
 tDy5Z0RUWZzWWAl42C167UiUB6dSjXdNQbWBjTvJ8Y+tbo1DIyV0JczI2K7jPSY16vBWj77/
 WlQJXrAvXT2/wq9QWIK4AgbtGJpxqJUjfoYz3GwzcD4kJ7huyZ7NprauKrE1h3/5DTe/nThY
 tFGB8beuekn59Gg6Nqh6xpauPYqXl2/DCMNsdLUa66ScSwga6VdxvmrjFX4HAW66TJNn5G5E
 FzMbunKCVzAM78CPazrRkDeFjrpsRL9p+1Yl0P6C2ct1jVe/+/TqU/Sr8NClUfOOHgE94W/V
 SDl5EYQ1gEB/yKv+WPpYGMaZYWK5UDunXF/MugHbiFeNmTBKysZ0SLWHhQDtO+pcobqVnEyS
 E5z9La5dQp5hC2B5D9V9sPD93IPp1Vz7QN5F11xSEausk/gd0cXxsRacyer3/JY+d65k+TPM
 0BXVaKitBQKVJxunil6wkpmk62SjZIkEJZgtztFNwNjoniDbJGoQR/OUPVlqF787TyFO/i9y
 /IGwYP02KkurxHRCneAETHoQKPOYU/XCLI3G3+N1qYrixacWpu/ibSN65CgsG9EX9DHRGXux
 1xy302iVFfM4Y6/tOiJhSUWJj+3uGA9u5S7IpbWMkrjOJkcPnkAJ+eF2UaQHpts1pY98IjOR
 rmEQ58BJK3b9CpRDJUqp1vAjGBRBrl+c8mNjyMjuvIaI0eEoZHEPPPwIhr/9BnfKnmsN+adP
 FmR4cwGzbiTIjvgKaLnvIkM96hLqHBaSnCWMJDrvWGp9Ji9v8BZBGCDtPTK9iS3OlUjhhAkY
 6ROP2mqg5OiGlv9X/ezkzFxstF0Lv6nqxGai0nYWAjayn9ACNjNys/ozo4nHJutMqUbkw1N4
 waTH6uIisoLWwSM05J9AuxH6+beflaI/fIiO0B+oA/r1z6NBf+gPCnoz8FMJvAXsZtBbHLQ3
 5GbA/9772Z4zXteLjom2yRyd7f0VLvLWbNaf/hI+yZXLNBGHSpyFdBDR9Urp+Cldk2EFKdYk
 Fy3MCUlJ6z+jVGGaSyzhK7VlDx3Mj4c0jX0bTdjvOl2HkRZ7NIe6b1szBV/QLTRRjF3yRxqv
 erphwE5t+FzSWWcO+naJRRr63oNuICE83cUZUM+gWMKClYDGLdhJV+01Aeq90UpyS5U9f75E
 Q1FCtov2LpZLNpG5BPfoNk1NXUcN9AZA7t1nkOxJl4R4+FC4d8wVVPy8Fn+zUDrLOvDUAp6a
 1ftW9YFZfWBVH7HqS+Ff84vZI7bJGo6FTJFqgcyA3MfrLdHwvEvYH9cX+f29DpHzrxPz6z17
 QPb4xhuvn9r1oeBNdMIYg/2O1kYA6W190NHayLGYrQMDTB887TPC3qBmQJ+rbzM8n0yP0NAL
 U5o5L/qOARtUI9SoT9MlOWa3ZwQhFMX8K3sPzkDDnjmhw8L+FG0XhTbaiDaGqpvlrVszKTcK
 /we4ILSWKslyRFZXyoWAYyzdeoTuKxGen5KfLFDtjvbYdj3pFZARXMnBKfnP8W2WYt1XimyL
 6/+jGPlEZw2IqyNebx2KR21u3NAaHeyN0A/ArjAEgp3bw8kryYUxPENDhqPwcPUZMMO+RWB5
 TulV5LCl07M9XdekxWeTIhA8uhqwlADfjzFGT3ofYkwk0nbqnFta00Tqi5d0O9IGPwiAv/OD
 HwXAn+ng4t2eXqwI4F6MCOAebHh2tsAP+Sw3thwBo5st0SindISM/TUySNokcxeye8byZDaM
 dZ0l+XpUiq7RqhicMMtXIB4ZzBP4h08dw4fQZvnNoaFHIxQLkJKg9irfyEtSW2FwVmOjN34n
 aKkitW/yL8cZMtg1xdDefqxpM2MaLIzXb2KfOczZz3wV16lNdGrfjBlpGMpmXc6M2pKae335
 g6l5A8BGJlygBxa+yx6sPtjMKlsbwrzW34vXqXcQYdjaqTNqU8842fj2g/gOHHwHPfAdBPEd
 OfiO+ujRkxDC+mod/lsQ39U6/DSIb8sOL/AyhsY6OsuvFMWXohExepykWq/J55vL0y2SGLL9
 d2YpJ3v+BfMX2zigY7q+GsptGF7ucvh13zGMyksQ/ZK92+T2ORF7X38ivO/D3foxCrgZXhlt
 50rIRECXlxMmGAgAlSMkIhO3KbBEuJhtc2TNn08QOyFZvYhFFoSe8NVP1pBu02jJXrFfvfUW
 NzQTT/oX3Od5LzbBOraKoiaeZ9j10Bl6ISe3niapa/LLbgrmcrbBVy3jCoZDE4OaLa5OBfTE
 p1O2YMkz5ctiZMhXXzlNpFlZEwFrHSHOESC4/ZiFr49kAEtul20IcWHCiwDCRqwFLcQEONU/
 6MkEuU5aqivlYzcfE429wfjmOkOtjvSDjCrArnWRBzy0wBx5i2cviMG3sKObfRKGiyopwIK1
 V4v7pcu3gNuTG6Ok1FVDjeFuFhgCfRboXNj209BreydsQBKdQihN9RXG1quRVvohHTkWgHqS
 hDl0k7mQHuPlG4MRM/hdRtLXbGyMeZ9A0ByO2ygFiZbs9E44a+uXGssnO6sTOZVNBSp2ncnp
 aREE2Djovh47I+5h3N+G7vQF2/Bz23xvlPzcb8mGydgzJSw9QgbUTBxxJ/NE0bj92Dw+D24J
 mygmJvHq5Ugrl1Ga6iXBJk7M61SIXst2Ywi7zMloMArkdBoMgg8dLFRYTEE1oMs4I8vMpTlG
 ySlOPmv5ffpbJUHNv8pYqPHQO2cGGMs0I3Kl6s4GyrtwYGnwhObqDdnewUAmgyam+DbpnhCi
 u9bwCuxYIiwt0UB3TaGIOpjKHzSHQMAq2oDZsT5M4hK9TsAzsdQUQgGFGjns6HpCc7eHh1d0
 kDbsuw1824PseYszKOs4tWDuxyFm6IMvjfQ84Lzh8WbPlhYYYTYbejb1bzo4+14Xp/TKd/cO
 m6TNzDM5xI+WRZvLPXM61AOh6KwqL5pT6UuzIrlBrxfyA9x6Ecc6oD9mxVrS2THwuGjs9tyG
 E0rUppAjSvQ57E2ubNV97MnJhQEVsghGZbyAhbBkToE8bhWxfBEzEOoslGG2YRRuUcvBDTVX
 SeIRTYw9ocDlBtWSqyeZ/MMp+gMdiCl344atg+xamOcgg2m0fN2gLN9+7D9QRj6aSJzUC2lp
 HA7TFIQZoqHRnL3GYGkQuMeGrkhvcFU0RClggQGPLhHnUpmFGVDGPBoRzg4O9EkdPEKs9qXE
 OPwQoOSOpnVJhKEgi6snylFOuxc599ulW3pH+WOALxDDaoBuOEsxEWasA9wySqELnj3edLfF
 mEyiMKBMe+yns3regHdtv1xwS/SQ9Vz3x8PJ6KSOaPAzJn+RHwSi/5bedRhq4kQctGT1odhq
 j/nDd9yoggVXgqxU2msgIq8v7QJN6WIxwh3Z/dHMcARSKXIWD96SQlWLfcmdpjt2roB8SHy2
 ARP7k/TUm2ajri3tgrE0mjpJEYug9ZY5zhoS3kcDka3JTlcYPlYiZoT4UHvETFVdrDFdEz15
 N+ZdmVZQ2PIb6EgaQL6qSvMnDSIdPkoM/HqN0sAmfizSBpaNFbNEDK7Bi0HcjK21ZUeKyEAX
 xqfd3XL2WgbWHGReOnnamPrbY/LnIq3lGG6MC3yONr25W8fnghPCGXOQrXpxYPCRcqCNWaCP
 la48f/zhrLo/dK665KOYFmZTzBM/CFlQrQPrHNAMQ+x5Q7rruDx6pbu/IuVvJKK9cGRwRlqS
 nfsnAoEVnvBBR8bHHBkVK4iPvmujVFFSeLyRQHf4c4PFP3qfBzYGttYrPCOr3t7V0loZOuO2
 C7UVglEq6QpGfaytE/1z6ZTaJVKmSt369++6EeImGuTzXeRga5mtUl6dUP3z0ARfHHTGm/bg
 OqeLR8tZBDoX+CjF7Tdq/aQZkKQtM3feE4PgmfUOPnu5JblUy9hbG3Ea435LF3A7pYB08p51
 6lRd2DE7a6iDuXjrtusXc72TizdfT+Vhg4GxdtPtSNI9HbG1FPPudscTZmR4A1lZqRAJzq2T
 swlHLQLbdoGmPVj+yBJkGgqo9Yb6xaWu5Y3A+u4vQZtw0sAgpO4yWYlQwx4YwS7RC3GmxYyJ
 NWfM1TJd7sZDBEpvrIBX+Hi+YVUeoxkWufdibhDm9QtZctHX7lqgIYGyL6wplRbq552CD5F1
 Uqgr5g0NmR71dop8iwB4O0MrP/b51IHmv7Kr1LI35OlcsD0gbYhn+ZtaRM/g71VeQMzm2Uq2
 lMY/PlclOPER9I2aTUXLB4x1RR5phwd8T2XQjQDr6tKg8+oSmA/6DE6aj/yvSUgQ2pNHzg4S
 euhpQo/+C7wzddHSmAscRF3ypMlWeSUs4q9WDYQqOzXai3r/9Fdat8yGI/YA1KWLi3DSnQ29
 Wp5XdTKQ+rw4pXPTUAAal0GFbZUD17QA0nNPiwqVY+cRTeh2qUWqMxXpI8YbuFdsfTmzzswl
 tIA4gdkv4yoZs4nOhV8+oGx079y544TI7sVR8ccjFLxCOjMb67eDzyM67LwB4d29HEs+bHYR
 eJaO5i1lSjpgmffGYsiUCdbdgE4Pl9GwAtfNdpczObbVYGSFz0aE7s0N3OCPQ5LVm1+opBDG
 m5HqkMGm/gh0Y7S3kTnkEhpqsrNWV1eF5fpyOfhfNlMv48jGAAA=
 
 --/04w6evG8XlLl3ft--
Comment 4 Volker Reichelt 2002-12-12 02:26:43 UTC
State-Changed-From-To: feedback->analyzed
State-Changed-Why: Confirmed.
    
    A smaller testcase is the following:
    
    ------------------------snip here---------------------------
    void foo();
    
    void bar()
    {
        struct A { A() { foo(); } } a;
    }
    ------------------------snip here---------------------------
    
    Compiling this with "g++ -fPIC -g1 -c" on i686-pc-linux-gnu I get an ICE:
    
    PR6387.cc:5: internal compiler error: in dwarf2out_finish, at dwarf2out.c:12611
    Please submit a full bug report, [etc.]
    
    The problem appeared in gcc 3.1 and affects the 3.2-branch and mainline.
    The code compiles fine with gcc 2.95.x and 3.0.x.
Comment 5 Wolfgang Bangerth 2002-12-14 13:30:50 UTC
From: Wolfgang Bangerth <bangerth@ticam.utexas.edu>
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: Re: c++/6387
Date: Sat, 14 Dec 2002 13:30:50 -0600 (CST)

 Just for the record: this patch (which was commited at the same time)
   diff -r1.12379 -r1.12380
   0a1,11
   > 2001-12-18  Jakub Jelinek  <jakub@redhat.com>
   >
   >       * config/linux.h (PREFERRED_DEBUGGING_TYPE): Remove. 
   >       * config/sparc/linux.h (PREFERRED_DEBUGGING_TYPE): Remove.
   >       * config/sparc/linux64.h (PREFERRED_DEBUGGING_TYPE): Remove.
   >       (CC1_SPEC): Don't default to -gstabs+ if -m32.
   >
   > 2001-12-05  David O'Brien  <obrien@FreeBSD.org>
   >
   >       * elfos.h (PREFERRED_DEBUGGING_TYPE): Change to DWARF2_DEBUG.
 
 is where high priority regression PR 6387 started, which has this 
 testcase:
 -----------------------
 void foo();
 void bar() {
   struct A { A() { foo(); } } a;
 }
 -----------------------
 and yields the following result with -g1 -fPIC:
 
 bash-2.05$ ../bin/gcc-2001-12-25/bin/c++ -fPIC -g1 -c PR6387.cc
   PR6387.cc:5: Internal compiler error in dwarf2out_finish, at 
   dwarf2out.c:11959
 
 Given the log message, it might well be that the problem originated 
 earlier and a change in meaning of -g1 now exposed the problem. Maybe the 
 authors of the patch can comment on how the new meaning of -g1 can be 
 reproduced with compilers that preceded this patch?
 
 Regards
   Wolfgang
 
 -------------------------------------------------------------------------
 Wolfgang Bangerth              email:           bangerth@ticam.utexas.edu
                                www: http://www.ticam.utexas.edu/~bangerth
 
 
 

Comment 6 Wolfgang Bangerth 2002-12-14 13:52:21 UTC
From: Wolfgang Bangerth <bangerth@ticam.utexas.edu>
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: Re: c++/6387
Date: Sat, 14 Dec 2002 13:52:21 -0600 (CST)

 > How about `-gdwaf -g1'?
 
 Close. The switch was to dwarf2. -gdwarf -g1 works before and after that 
 change, -gdwarf-2 -g1 does not work before or after the change. So I'll at 
 this to flags and run it again. (Sorry for not noticing it before, I tried 
 -gdwarf-2 alone, but did not realize that it is necessary to use -g1 as 
 well...)
 
 With -gdwarf-2 -g1, the failure appeared before 2001-01-01, which 
 presently the limit of the compilers I have on my disk, so I won't be able 
 to check this further.
 
 Regards
   Wolfgang
 
 -------------------------------------------------------------------------
 Wolfgang Bangerth              email:           bangerth@ticam.utexas.edu
                                www: http://www.ticam.utexas.edu/~bangerth
 
 
 
Comment 7 Jason Merrill 2003-03-14 20:25:27 UTC
Responsible-Changed-From-To: unassigned->jason
Responsible-Changed-Why: got it
Comment 8 Jason Merrill 2003-03-15 17:00:15 UTC
From: jason@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: debug/6387
Date: 15 Mar 2003 17:00:15 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Branch: 	gcc-3_3-branch
 Changes by:	jason@gcc.gnu.org	2003-03-15 17:00:15
 
 Modified files:
 	gcc            : ChangeLog dwarf2out.c 
 
 Log message:
 	PR debug/6387
 	* dwarf2out.c (dwarf2out_decl): If we're at -g1, just stick nested
 	function DIEs at toplevel.
 	(decls_for_scope): At -g1, don't descend into subblocks.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_3-branch&r1=1.16114.2.303&r2=1.16114.2.304
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/dwarf2out.c.diff?cvsroot=gcc&only_with_tag=gcc-3_3-branch&r1=1.390.2.2&r2=1.390.2.3
 

Comment 9 Jason Merrill 2003-03-15 17:06:24 UTC
From: jason@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: debug/6387
Date: 15 Mar 2003 17:06:24 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Changes by:	jason@gcc.gnu.org	2003-03-15 17:06:24
 
 Modified files:
 	gcc            : ChangeLog dwarf2out.c 
 
 Log message:
 	PR debug/6387
 	* dwarf2out.c (dwarf2out_decl): If we're at -g1, just stick nested
 	function DIEs at toplevel.
 	(decls_for_scope): At -g1, don't descend into subblocks.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/ChangeLog.diff?cvsroot=gcc&r1=1.17094&r2=1.17095
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/dwarf2out.c.diff?cvsroot=gcc&r1=1.409&r2=1.410
 
Comment 10 Nathanael C. Nerode 2003-03-21 06:08:51 UTC
State-Changed-From-To: analyzed->open
State-Changed-Why: Confirmed fixed in 3.3 and mainline as of 2003-03-21.
Comment 11 Nathanael C. Nerode 2003-03-21 06:09:13 UTC
State-Changed-From-To: open->analyzed
State-Changed-Why: toggling state
Comment 12 Joe Buck 2003-04-25 20:05:38 UTC
State-Changed-From-To: analyzed->closed
State-Changed-Why: Fixed in 3.3.